/*
 * #%L
 * *********************************************************************************************************************
 * 
 * SolidBlue - open source safe data
 * http://solidblue.tidalwave.it - hg clone https://bitbucket.org/tidalwave/solidblue-src
 * %%
 * Copyright (C) 2011 - 2013 Tidalwave s.a.s. (http://tidalwave.it)
 * %%
 * *********************************************************************************************************************
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * *********************************************************************************************************************
 * 
 * $Id$
 * 
 * *********************************************************************************************************************
 * #L%
 */
package it.tidalwave.integritychecker.impl;

import javax.annotation.Nonnull;
import it.tidalwave.actor.impl.io.fileload.FileLoaderActor;
import it.tidalwave.actor.impl.io.filescan.FileObjectDiscoveryActor;
import it.tidalwave.actor.spi.ActorGroupActivator;
import it.tidalwave.netbeans.actor.ActorActivatorInstallSupport;
import it.tidalwave.integritychecker.impl.fingerprint.FingerprintComputerActor;
import lombok.extern.slf4j.Slf4j;
import static it.tidalwave.actor.spi.ActorActivator.*;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Slf4j
public class Installer extends ActorActivatorInstallSupport
  {
    @Override
    protected void registerActors (final @Nonnull ActorGroupActivator a) 
      {
        a.add(activatorFor(FileObjectDiscoveryActor.class).withPoolSize(8));
        a.add(activatorFor(FileLoaderActor.class).withPoolSize(1));
        a.add(activatorFor(FingerprintComputerActor.class).withPoolSize(4));
        a.add(activatorFor(MessageRouter.class).withPoolSize(1));
      }
  }